
// O[oϐ
// vOCWœn
float4x4 matWorld;			// [hs
float4x4 matView;			// r[s
float4x4 matWVP;			// [h~r[~vWFNV̍s
float4x4 matPrevWorld;		// ߋ[hs
float4x4 matPrevView;		// ߋr[s
float4x4 matPrevWVP;		// ߋ[hr[vWFNVs

float3 CamPos;				// J̍W
float3 CamDir;				// J̌

float3 LightDir[3];			// 
float3 LightCol[3];			// FEfBt[Y
float3 LightSpc[3];			// FEXyL

float4 Diffuse;
float4 Ambient;
float4 Emissive;
float4 Specular;
float  SpecularPower;

texture2D diffuseMap;
texture2D emissiveMap;
texture2D specularMap;
texture2D environmentMap;
texture2D normalMap;

bool useEnvironmentMap = 0;
bool useNormalMap = 0;

int faceRight = 3;			// \ 3=CCW 2=CW 1or0=None
int faceWrong = 2;			// 

float3 offsetUV;			// UVXN[



// O[oϐ
// HSPn
float4x4 matWVPT;			// eNX`Wϊp
float4x4 matLightWVPT;		// Cg_̍WeNX`Wɕϊs
float4x4 matInvVP;			// r[~vWFNV̋ts@[xW̋tZp
float4x4 matInvPrevVP;		// ߋr[vWFNVts

texture2D shadowMap;
texture2D nmldptMap;

bool useShadowMap = 0;



// eNX`Tv
sampler2D diffuseSampler {
	Texture = <diffuseMap>;
	AddressU = Wrap;			// AhbVO[h Wrap Border Mirror MirrorOnce Clamp
	AddressV = Wrap;			// Wrap ƃeNX`̒[[v
	AddressW = Wrap;			// W 3eNX`p
	MagFilter = Anisotropic;	// gtB^ None Point Linear Anisotropic PyramidalQuad GaussianQuad
	MinFilter = Anisotropic;	// ktB^
	MipFilter = Linear;			// ~bv}bvtB^ None Point Linear
	MipMapLodBias = 0.0f;		// ~bv}bvoCAX Ƌ߂܂Ń{P Ɖ܂ŃV[v -0.5ӂ肪
	MaxAnisotropy = 4;			// ٕtB^ől 1~16 4ݒ肵ĂΊƃLC
};

sampler2D emissiveSampler {
	Texture = <emissiveMap>;
	AddressU = Wrap;
	AddressV = Wrap;
	MagFilter = Anisotropic;
	MinFilter = Anisotropic;
	MipFilter = Linear;
	MipMapLodBias = 0.0f;
	MaxAnisotropy = 4;
};

sampler2D specularSampler {
	Texture = <specularMap>;
	AddressU = Wrap;
	AddressV = Wrap;
	MagFilter = Anisotropic;
	MinFilter = Anisotropic;
	MipFilter = Linear;
	MipMapLodBias = 0.0f;
	MaxAnisotropy = 4;
};

sampler2D environmentSampler {
	Texture = <environmentMap>;
	AddressU = Wrap;
	AddressV = Wrap;
	MagFilter = Anisotropic;
	MinFilter = Anisotropic;
	MipFilter = Linear;
	MipMapLodBias = 0.0f;
	MaxAnisotropy = 4;
};

sampler2D normalSampler {
	Texture = <normalMap>;
	AddressU = Wrap;
	AddressV = Wrap;
	MagFilter = Anisotropic;
	MinFilter = Anisotropic;
	MipFilter = Linear;
	MipMapLodBias = 0.0f;
	MaxAnisotropy = 4;
};

sampler2D shadowSampler {
	Texture = <shadowMap>;
	AddressU = Border;			// Border ƃeNX`̓[vAeNX`O BorderColor ɂȂ
	AddressV = Border;
	BorderColor = 0xffffffff;
	MagFilter = Linear;
	MinFilter = Linear;
	MipFilter = Linear;
};

sampler2D nmldptSampler {
	Texture = <nmldptMap>;
	AddressU = Clamp;			// Clamp ƃeNX`̒[̐FOɑ
	AddressV = Clamp;
	MagFilter = Linear;
	MinFilter = Linear;
	MipFilter = Linear;
};

// Rp̃eNX`Tv
sampler3D volumeSampler {
	Texture = <diffuseMap>;		// _ł diffuseMap Ƀ{[eNX`w肳ꂽꍇz肷
	AddressU = Wrap;
	AddressV = Wrap;
	AddressW = Wrap;
	MagFilter = Linear;
	MinFilter = Linear;
	MipFilter = Linear;
};



// _VF[_
struct VS_IN {
	float4 pos     : POSITION;
	float4 color   : COLOR0;
	float3 normal  : NORMAL;
	float4 tangent : TANGENT;
	float3 uv      : TEXCOORD0;
	float4 prevpos : POSITION1;
};

struct VS_OUT {
	float4 pos      : POSITION;
	float4 color    : COLOR0;
	float3 uv       : TEXCOORD0;
	float3 normal   : TEXCOORD1;
	float3 tangent  : TEXCOORD2;
	float3 binormal : TEXCOORD3;
	float3 eye      : TEXCOORD4;
	float4 poslittex : TEXCOORD5;
};

VS_OUT Diffuse_VS( VS_IN In )
{
	VS_OUT Out;
	Out.pos		= mul( In.pos, matWVP );							// _Wϊ

	Out.normal	= mul( In.normal, (float3x3)matWorld );				// @xNg]
	if( useNormalMap ){
		Out.tangent		= mul( In.tangent.xyz, (float3x3)matWorld );		// ڐxNg]
		Out.binormal	= cross( Out.normal, Out.tangent ) * In.tangent.w;	// ڐƖ@]@߂
	}

	Out.uv		= In.uv + offsetUV;									// UVW
	Out.color	= In.color;											// _F
	Out.eye		= normalize( CamPos - In.pos );						// _王_̃xNg

	if( useShadowMap ){
		Out.poslittex	= mul( In.pos, matLightWVPT );				// Cg_̍WeNX`Wɕϊ
	}
	// ̒x̌vZȂ番򂳂肻̂܂܌vZ肷邩ȁH

	return Out;
}

VS_OUT AfterImage_VS( VS_IN In )
{
	VS_OUT Out;

	// _ߋɈ
	// ꉞ肭sĂ݂
	float4x4 matWV = mul( matWorld, matView );
	float4x4 matPrevWV = mul( matPrevWorld, matPrevView );
	float3 normal = mul( In.normal, (float3x3)matWV );	// r[ԏ̖@xNg
	float3 curVPos = mul( In.pos, matWV );				// r[ԏ݂̌̍W
	float3 prevVPos = mul( In.prevpos, matPrevWV );		// r[ԏ̉ߋ̍W
	float3 vel = curVPos - prevVPos;					// r[ԏ̈ړ  x
	float d = dot( normal, vel );						// @ƈړx̃xNg̓ςstep()Ɋ|
	d = step( 0.0f, d );								// d  0ȏゾ 1 łȂ 0 Ԃ
	float4 curPos = mul( In.pos, matWVP );				// ˉeԏ݂̌̍W
	float4 prevPos = mul( In.prevpos, matPrevWVP );		// ˉeԏ̉ߋ̍W
	Out.pos = d * curPos + (1.0f - d) * prevPos;		// @ƈړx̃xNǧ̊֌WA݂Ɖߋ̍WU蕪

	Out.normal	= mul( In.normal, (float3x3)matWorld );				// @xNg]
	if( useNormalMap ){
		Out.tangent		= mul( In.tangent.xyz, (float3x3)matWorld );		// ڐxNg]
		Out.binormal	= cross( Out.normal, Out.tangent ) * In.tangent.w;	// ڐƖ@]@߂
	}

	Out.uv		= In.uv + offsetUV;									// UVW
	Out.color	= In.color;											// _F
	Out.eye		= normalize( CamPos - In.pos );						// _王_̃xNg

	if( useShadowMap ){
		Out.poslittex	= mul( In.pos, matLightWVPT );				// Cg_̍WeNX`Wɕϊ
	}

	return Out;
}



// ֊s|Sp
struct Edge_VS_OUT {
	float4 pos    : POSITION;
	float4 color  : COLOR0;
	float2 uv     : TEXCOORD0;
	float3 normal : TEXCOORD1;
};

Edge_VS_OUT Edge_VS( VS_IN In )
{
	Edge_VS_OUT Out;

	float4 tmpPos	= In.pos;
	tmpPos.xyz		+= In.normal.xyz * 0.016;
	Out.pos			= mul( tmpPos, matWVP );

	Out.normal		= mul( In.normal, (float3x3)matWorld );
	// ֊spsNZVF[_ŎgĂȂ疳Ăǂ
	// ֊sɉAetȂKv

	Out.uv			= In.uv + offsetUV;
	Out.color		= In.color;
	Out.color.xyz	*= 0.333333;					// 邳1/3
	return Out;
}



// m[}}bvLȂm[}}bv̖@ĕԂ
float3 CalcNormal( float3 Tang, float3 BiNorm, float3 Norm, float2 uv )
{
	if( useNormalMap ){
		float3x3 mat = { normalize( Tang ), normalize( BiNorm ), normalize( Norm ) };	// R̃xNg]s
		float3 TexNml = tex2D( normalSampler, uv );		// @}bv̐F
		TexNml = normalize( 2.0f * TexNml - 1.0f );		// xNgɕϊ
		return mul( TexNml, mat );						// xNgsŉ]
	}else{
		return normalize( Norm );
	}
}


// ʂ̃VhE}bv
float CalcShadowMap( float4 poslittex )
{
	float z = tex2Dproj( shadowSampler, poslittex ).x;
	float d = poslittex.z;
	if( d > z + 0.005f ){							// VhE}bv̐[x[
		return 0.0f;								// eɂȂ
	}else{
		return 1.0f;								// Ă
	}
}

// UVhE}bv
float CalcVSM( float4 poslittex )
{
	float2	depth = tex2Dproj( shadowSampler, poslittex ).xy;
	float	d = poslittex.z;
	float	variance = min( max( depth.y - (depth.x * depth.x), 0.0f ) + 0.0001f, 1.0f );
	float	md = d - depth.x;
	float	pmax = variance / (variance + (md * md));
	return pow( max( d <= depth.x, pmax ), 3.0f );
	// 悩ȂƉe𗎂ƂʂƎ󂯂ʂ߂ꏊŉeȂ
	// ZƔꏊŃ`cL₷Ȃ
	// variance őĂlƃ`cĽɂȂ
	// VhE}bv̐xƃ`cLɂ悤
}

// wVhE}bv
float CalcESM( float4 poslittex )
{
	float z = tex2Dproj( shadowSampler, poslittex ).x;
	float d = poslittex.z;
	float c = 80.0f;
	float ez = exp(  c * z );
	float ed = exp( -c * d );
	return saturate( ez * ed );
	// e𗎂ƂʂƎ󂯂ʂ߂ꏊŉeȂ
	// c 傫鎖ŔZo邪AE
}

float CalcShadow( float4 poslittex )
{
	if( useShadowMap ){
	//	return CalcShadowMap( poslittex );		// VhE}bv
	//	return CalcVSM( poslittex );			// UVhE}bv(VSM)
		return CalcESM( poslittex );			// wVhE}bv(ESM)
	}else{
		return 1.0f;		// VhE}bvgȂꍇ͏ 1.0f
	}
}



// }bv
float3 CalcEnvMap( float3 Norm )
{
	if( useEnvironmentMap ){
		Norm = mul( Norm, (float3x3)matView );		// ̂܂܂ƃ[hԏ̌Ȃ̂Ńr[sŕϊ
///*
		float2 EnvUV;
		EnvUV.x = Norm.x *  0.5 - 0.5;
		EnvUV.y = Norm.y * -0.5 - 0.5;
		return tex2D( environmentSampler, EnvUV );	// _ł̓XtBA}bvp
//*/
/*
		float4 EnvUV;
		EnvUV.x = Norm.x *  0.5 - 0.5;
		EnvUV.y = Norm.y * -0.5 - 0.5;
		EnvUV.z = 0.0;
		EnvUV.w = 4.0;		// ǂ MipMapLodBias Ɠۂ
		return tex2Dbias( environmentSampler, EnvUV );
		// w 𔽎˗ŕω悤ɂ烊A
*/
	}else{
		return float3( 0.0f, 0.0f, 0.0f );
	}
}



// sNZVF[_
struct PS_IN {
	float4 color    : COLOR0;
	float3 uv       : TEXCOORD0;
	float3 normal   : TEXCOORD1;
	float3 tangent  : TEXCOORD2;
	float3 binormal : TEXCOORD3;
	float3 eye      : TEXCOORD4;
	float4 poslittex : TEXCOORD5;
};

float4 Phong_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex2D( diffuseSampler,  In.uv );
	float3 TexEmi = tex2D( emissiveSampler, In.uv );
	float4 TexSpc = tex2D( specularSampler, In.uv );

	// m[}}bv
	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, In.uv );

	// XtBA}bv
	float3 TexEnv = CalcEnvMap( Norm );

	// VhE}bv
	float InTheLight = CalcShadow( In.poslittex );

//	float dif_coef = dot( Norm, LightDir );		// @ƌ̓ρEgU˂̋
/*
	float3 Reflect = normalize( 2 * dif_coef * Norm - LightDir );
	float spc_coef = pow( saturate( dot(Reflect, In.eye) ), SpecularPower );
	// 𔽎˂āÃxNgƎ̓ς
	// ̂ƕʃ|SɃJڋ߂̌̏o_̖xɈˑĂ܂悤
	// ʏ̒_̈ʒu֌WɌ炸A_̌ɂȂĂ܂݂̒_VF[_̎dl
*/
/*
	float3 Reflect = normalize( 2 * dot( Norm, In.eye ) * Norm - In.eye );
	float spc_coef = pow( saturate( dot( Reflect, LightDir ) ), SpecularPower );
	// 𔽎˂āÃxNgƌ̓ς悤ɂĂ݂
*/
/*
	float4 colDif = TexDif * ( Ambient + In.color * max( 0, dif_coef ) );
	float4 colSpc = TexSpc * Specular * spc_coef;
	float4 colEmi = TexEmi * Emissive;
	float4 col = colDif + colSpc + colEmi;
	col.w = colDif.w * TexDif.w * In.color.w;
*/

	float3 Reflect = normalize( 2 * dot( Norm, In.eye ) * Norm - In.eye );	// ˂߂
	float3 sumDif = { 0.0f, 0.0f, 0.0f };
	float3 sumSpc = { 0.0f, 0.0f, 0.0f };
	for( int i=0; i<3; i++ ){
		sumDif += LightCol[i] * max( 0, dot( Norm, LightDir[i] ) );
		sumSpc += LightSpc[i] * pow( saturate( dot( Reflect, LightDir[i] ) ), SpecularPower*TexSpc.w );
	}

	float3 colDif = TexDif * ( Ambient + Diffuse * In.color * sumDif * InTheLight );
	// ArGgeNX`̐F̉e󂯂悤ɂĂ
	// ̓sA^ZRł̕\ÂȂ肪Ȃ̂
	// KvłHSPXNvgArGgグ悤ɂ
	// @ArGgMQOfǂݍ񂾎_ 0.25{
	// @^ZŔA͌iArGgj1.0ɐݒ肵Ă0.25̖邳Ŕf

	float3 colSpc = TexSpc * Specular * ( TexEnv + sumSpc * InTheLight );
	// ̃VF[_ł͊}bvỉf荞݁EʔˁjƂĈ
	// Ȃ̂łŃXyLpeNX`̉e󂯂
	// ẻe͎󂯂Ȃ

	float3 colEmi = TexEmi * Emissive * In.color;
	// TexEmi ̓G~bVup̃eNX`AIuWFNgɐݒ肳ĂȂꍇ TexDif ƓeɂȂ
	// ܂AG~bVueNX`ꍇ̓fBt[Y̐FŌ

	float4 col;
	col.xyz = colDif + colSpc + colEmi;
	col.w   = TexDif.w * Diffuse.w * In.color.w;
	return col;
}



float4 Volume_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex3D( volumeSampler,  In.uv );
	float3 TexEmi = tex2D( emissiveSampler, In.uv );
	float4 TexSpc = tex2D( specularSampler, In.uv );

	// m[}}bv
	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, In.uv );

	// XtBA}bv
	float3 TexEnv = CalcEnvMap( Norm );

	// VhE}bv
	float InTheLight = CalcShadow( In.poslittex );

	float3 Reflect = normalize( 2 * dot( Norm, In.eye ) * Norm - In.eye );	// ˂߂
	float3 sumDif = { 0.0f, 0.0f, 0.0f };
	float3 sumSpc = { 0.0f, 0.0f, 0.0f };
	for( int i=0; i<3; i++ ){
		sumDif += LightCol[i] * max( 0, dot( Norm, LightDir[i] ) );
		sumSpc += LightSpc[i] * pow( saturate( dot( Reflect, LightDir[i] ) ), SpecularPower*TexSpc.w );
	}

	float3 colDif = TexDif * ( Ambient + Diffuse * In.color * sumDif * InTheLight );
	float3 colSpc = TexSpc * Specular * ( TexEnv + sumSpc * InTheLight );
	float3 colEmi = TexEmi * Emissive * In.color;
	float4 col;
	col.xyz = colDif + colSpc + colEmi;
	col.w   = TexDif.w * Diffuse.w * In.color.w;
	return col;
}



float4 BlinnPhong_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex2D( diffuseSampler,  In.uv );
	float3 TexEmi = tex2D( emissiveSampler, In.uv );
	float4 TexSpc = tex2D( specularSampler, In.uv );

	// m[}}bv
	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, In.uv );

	// XtBA}bv
	float3 TexEnv = CalcEnvMap( Norm );

	// VhE}bv
	float InTheLight = CalcShadow( In.poslittex );

	float3 Reflect;
	float3 sumDif = { 0.0f, 0.0f, 0.0f };
	float3 sumSpc = { 0.0f, 0.0f, 0.0f };
	for( int i=0; i<3; i++ ){
		sumDif += LightCol[i] * max( 0, dot( Norm, LightDir[i] ) );
		Reflect = normalize( In.eye + LightDir[i] );
		sumSpc += LightSpc[i] * pow( saturate( dot( Reflect, Norm ) ), SpecularPower*TexSpc.w );
	}
	float3 colDif = TexDif * ( Ambient + Diffuse * In.color * sumDif * InTheLight );
	float3 colSpc = TexSpc * Specular * ( TexEnv + sumSpc * InTheLight );
	float3 colEmi = TexEmi * Emissive * In.color;
	float4 col;
	col.xyz = colDif + colSpc + colEmi;
	col.w   = TexDif.w * Diffuse.w * In.color.w;
	return col;
}
// ^ZR̃uVF[fBO͂ǂuBlinn-Phongv̂悤
// ̏oPhongƈĊۂ݂ێ
// fBt[Y̌vZɂƉA̋ڂHݏoČ򂪂ɂ



//----------------------------------------------------------------------------------
// Name : CalculateBeckmann()
// Desc : Beckmannz֐̌vZ
//----------------------------------------------------------------------------------
float CalculateBeckmann(float m, float cosbeta)
{
	return exp(-(1-(cosbeta*cosbeta))/(m*m*cosbeta*cosbeta))/(4*m*m*cosbeta*cosbeta*cosbeta*cosbeta);
}

const float PI = 3.14159265358979323846;
float Beckmann(float m, float t)
{
    float M = m*m;
    float T = t*t;
    return exp((T-1)/(M*T)) / (PI*M*T*T);
}
// ͎኱򂪋H

//----------------------------------------------------------------------------------
// Name : CalculateFresnelTerm()
// Desc : tľvZ
//----------------------------------------------------------------------------------
float CalculateFresnelTerm(float n, float c)
{
	float g = sqrt(n*n + c*c - 1);
	float T1 = ((g-c)*(g-c))/((g+c)*(g+c));
	float T2 = 1 + ( (c*(g+c)-1)*(c*(g+c)-1) )/( (c*(g-c)+1)*(c*(g-c)+1) );
	return 0.5 * T1 * T2;
}

float3 CalculateFresnelTerm( float3 n, float c )
{
	return float3( CalculateFresnelTerm(n.x,c), CalculateFresnelTerm(n.y,c), CalculateFresnelTerm(n.z,c) );
}
//  ΋ܗ w肷
// ΋ܗ ˗f0 Ƃ (1.0+sqrt(f0)) / (1.0-sqrt(f0)) ŋ܂

// tľvZiߎj
//  Ƃ0iˁj̎̔˗ 0`1 w肷
float3 FresnelTerm( float3 Rs, float LH )
{
	return ( Rs + (1-Rs) * pow(1-LH,5) );			// Fr()=F0+(1-F0)(1-cos)^5
}



float4 CookTorrance_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex2D( diffuseSampler,  In.uv );
	float3 TexEmi = tex2D( emissiveSampler, In.uv );
	float4 TexSpc = tex2D( specularSampler, In.uv );

	// m[}}bv
	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, In.uv );

	// XtBA}bv
	float3 TexEnv = CalcEnvMap( Norm );

	// VhE}bv
	float InTheLight = CalcShadow( In.poslittex );

	float Microfacet = 4.0f * pow( 0.92f, SpecularPower * TexSpc.w ) + 0.01;
	// ̒lƌ򂪏ȂA傫ƍLAȏ傫ƃOɂȂ
	// ω̏oƐ`ۂ̂ŁAl傫قǕωȂ鑼̌ƌڂvȂ
	// Ƃ肠 SpecularPower ɔfĂ݂
	// ƋPxȂ̂ŁAVhE}bvŎՂĂςȂƂ
	// ƔׂƈȂ

	float3 Rs = TexSpc * Specular;			// XyLtN^X f0
	// ɐݒ肵F̐FɂȂ邪A[ɂĂキȂ邾Ō͏Ȃ悤

	float3 N = Norm;						// @xNg
	float3 V = In.eye;						// xNg
	float3 sumDif = { 0.0f, 0.0f, 0.0f };
	float3 sumSpc = { 0.0f, 0.0f, 0.0f };
	for( int i=0; i<3; i++ ){
		float3 L = LightDir[i];				// CgxNg
		float3 H = normalize( L + V );		// n[txNg
		float NV = dot( N, V );				// vZɎgpx
		float NH = dot( N, H );
		float VH = dot( V, H );
		float NL = dot( N, L );

//		float D = CalculateBeckmann( Microfacet, NH );			// Beckmannz֐
		float D = Beckmann( Microfacet, NH );					// Beckmannz֐

		float G = min( 1, min( 2*NH*NV/VH, 2*NH*NL/VH ) );		// 􉽌
		float3 F = FresnelTerm( Rs, dot(L, H) );				// tl
		sumDif += LightCol[i] * max( 0, NL );
		sumSpc += LightSpc[i] * max( 0, F*D*G/NV );
	}
	float3 colDif = TexDif * ( Ambient + Diffuse * In.color * sumDif * InTheLight );
	float3 colSpc = TexSpc * Specular * ( TexEnv + sumSpc * InTheLight );
	float3 colEmi = TexEmi * Emissive * In.color;
	float4 col;
	col.xyz = colDif + colSpc + colEmi;
	col.w   = TexDif.w * Diffuse.w * In.color.w;
	return col;
}
// PhongBlinn-PhongɔׂƁAȂccƂɂȂ
// キݒ肵ĂEE@̊֌WɂĂ͋򂪏ô
// ǂdɂȂ@\ɌĂƂ]ʂ
// Microfacet ̒l傫
// {P̖  ĉ{P  c̖{P  Ǒ
// Ƃɕω邪AL̂RԂƂSԂ̊ԂŒ
// ̂ziƂw@ہjۂȂ̂ŁA\ȊOɂg
// @͌򂪔ꍇ̘bŁAɐFƂςۂȂ



//----------------------------------------------------------------------------------
// Trowbridge-Reitz (GGX) NDF
float sqr(float x) { return x*x; }
float GGX(float alpha, float cosThetaM)
{
    float CosSquared = cosThetaM*cosThetaM;
    float TanSquared = (1-CosSquared)/CosSquared;
    return (1.0/PI) * sqr(alpha/(CosSquared * (alpha*alpha + TanSquared)));
}

float4 TrowbridgeReitz_PS( PS_IN In ) : COLOR0
{
///*
	float4 TexDif = tex2D( diffuseSampler,  In.uv );
	float3 TexEmi = tex2D( emissiveSampler, In.uv );
	float4 TexSpc = tex2D( specularSampler, In.uv );

	// m[}}bv
	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, In.uv );
//*/
/*
	// }bsO
	float3 E = normalize( In.eye );								// xNg
	float  Hgt = 1.0f - tex2D( normalSampler, In.uv ).w;		// m[}}bṽAt@ƂĎ擾
	float3 NTan = normalize( In.tangent );
	float3 NBnm = normalize( In.binormal );
	float2 Diff = float2( -dot( NTan, E ), dot( NBnm, E ) );	// xNgeNX`ɓe
	float2 uv = In.uv + 0.03 * Hgt * Diff;						// UV炷ʂƂĉZ

	float4 TexDif = tex2D( diffuseSampler,  uv );
	float3 TexEmi = tex2D( emissiveSampler, uv );
	float4 TexSpc = tex2D( specularSampler, uv );

	// m[}}bv
	float3 Norm = CalcNormal( In.tangent, In.binormal, In.normal, uv );
*/

	// XtBA}bv
	float3 TexEnv = CalcEnvMap( Norm );

	// VhE}bv
	float InTheLight = CalcShadow( In.poslittex );

	float Microfacet = 4.0f * pow( 0.92f, SpecularPower * TexSpc.w ) + 0.01;
	float3 Rs = TexSpc * Specular;			// XyLtN^X f0

	float3 N = Norm;						// @xNg
	float3 V = In.eye;						// xNg
	float3 sumDif = { 0.0f, 0.0f, 0.0f };
	float3 sumSpc = { 0.0f, 0.0f, 0.0f };
	for( int i=0; i<3; i++ ){
		float3 L = LightDir[i];				// CgxNg
		float3 H = normalize( L + V );		// n[txNg
		float NV = dot( N, V );				// vZɎgpx
		float NH = dot( N, H );
		float VH = dot( V, H );
		float NL = dot( N, L );

		float D = GGX( Microfacet, NH );						// GGX

		float G = min( 1, min( 2*NH*NV/VH, 2*NH*NL/VH ) );		// 􉽌
		float3 F = FresnelTerm( Rs, dot(L, H) );				// tl
		sumDif += LightCol[i] * max( 0, NL );
		sumSpc += LightSpc[i] * max( 0, F*D*G/NV );
	}
	float3 colDif = TexDif * ( Ambient + Diffuse * In.color * sumDif * InTheLight );
	float3 colSpc = TexSpc * Specular * ( TexEnv + sumSpc * InTheLight );
	float3 colEmi = TexEmi * Emissive * In.color;
	float4 col;
	col.xyz = colDif + colSpc + colEmi;
	col.w   = TexDif.w * Diffuse.w * In.color.w;
	return col;
}
// CookTorrance  Beckmannz֐ GGX ɒuĂ݂
// CookTorrance ƔׂƎア͈̔͂L̂



// ֊s|SpsNZVF[_
float4 Edge_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex2D( diffuseSampler,  In.uv );
	float4 TexEmi = tex2D( emissiveSampler, In.uv );
	float4 colDif = TexDif * ( Ambient + Diffuse * In.color );
	float4 colEmi = TexEmi * Emissive * In.color;
	float4 col = colDif + colEmi;
	col.w = TexDif.w * Diffuse.w * In.color.w;
	return col;
}



// VF[fBOȂ\p
// fBt[YJ[𔽉f
float4 Constant_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex2D( diffuseSampler,  In.uv );
	float4 colDif = TexDif * Diffuse * In.color;
	return colDif;
}



// eNjbN
technique BasicTec
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 Phong_PS();
		CullMode = faceRight;	// \ʕ\
	}
}


technique TestTec
{
	pass P0
	{
		VertexShader = compile vs_2_0 AfterImage_VS();
		PixelShader = compile ps_3_0 TrowbridgeReitz_PS();
		CullMode = faceRight;	// \ʕ\
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Edge_VS();
		PixelShader = compile ps_2_0 Edge_PS();
		CullMode = faceWrong;
	}
}


technique VolumeTex
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 Volume_PS();
		CullMode = faceRight;	// \ʕ\
	}
}


technique Phong
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 Phong_PS();
		CullMode = faceRight;
	}
}

technique PhongWithEdge
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 Phong_PS();
		CullMode = faceRight;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Edge_VS();
		PixelShader = compile ps_2_0 Edge_PS();
		CullMode = faceWrong;
	}
}

technique BlinnPhong
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 BlinnPhong_PS();
		CullMode = faceRight;
	}
}

technique BlinnPhongWithEdge
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 BlinnPhong_PS();
		CullMode = faceRight;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Edge_VS();
		PixelShader = compile ps_2_0 Edge_PS();
		CullMode = faceWrong;
	}
}

technique CookTorrance
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 CookTorrance_PS();
		CullMode = faceRight;
	}
}

technique CookTorranceWithEdge
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 CookTorrance_PS();
		CullMode = faceRight;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Edge_VS();
		PixelShader = compile ps_2_0 Edge_PS();
		CullMode = faceWrong;
	}
}

technique TrowbridgeReitz
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 TrowbridgeReitz_PS();
		CullMode = faceRight;
	}
}

technique TrowbridgeReitzWithEdge
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 TrowbridgeReitz_PS();
		CullMode = faceRight;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Edge_VS();
		PixelShader = compile ps_2_0 Edge_PS();
		CullMode = faceWrong;
	}
}

technique Constant
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 Constant_PS();
		CullMode = faceRight;
	}
}

technique ConstantWithEdge
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 Constant_PS();
		CullMode = faceRight;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Edge_VS();
		PixelShader = compile ps_2_0 Edge_PS();
		CullMode = faceWrong;
	}
}



#include "depthplot.fx"
#include "nmldpt.fx"
#include "pntlit.fx"
#include "blur.fx"
#include "line.fx"
#include "pxedge.fx"
#include "visweight.fx"


