// `pɗpӂĂ݂



// O[oϐ
float4x4 matWVP;
texture2D fontMap;
float4 fontColor0;
float4 fontColor1;
float shadowX;			// hbvVhẼY
float shadowY;
float blurDist;			// eNX`ڂp



// eNX`Tv
sampler2D SampPoint {
	Texture = <fontMap>;
	AddressU = Clamp;
	AddressV = Clamp;
	MagFilter = Point;	// `͊{IɃhbgoChbgȂ̂
	MinFilter = Point;	// `Ԃ͗vȂ
};
sampler2D SampLinear {
	Texture = <fontMap>;
	AddressU = Clamp;
	AddressV = Clamp;
	MagFilter = LINEAR;
	MinFilter = LINEAR;
};



// _VF[_
struct VS_IN {
	float4 pos    : POSITION;
	float2 uv     : TEXCOORD0;
};

struct VS_OUT {
	float4 pos    : POSITION;
	float2 uv     : TEXCOORD0;
};

VS_OUT Diffuse_VS( VS_IN In )
{
	VS_OUT Out;
	Out.pos = mul( In.pos, matWVP );
	Out.uv = In.uv;
	return Out;
}

VS_OUT DropShadow_VS( VS_IN In )
{
	VS_OUT Out;
	Out.pos = mul( In.pos, matWVP );
	Out.pos.x += shadowX;		// EƉɂꂼ1hbg炷
	Out.pos.y -= shadowY;		// 1hbg̒l̓vOŌvZĂ
	Out.uv = In.uv;
	return Out;
}


// sNZVF[_
struct PS_IN {
	float2 uv     : TEXCOORD0;
};

// ʏ\
float4 Diffuse_PS( PS_IN In ) : COLOR0
{
	return tex2D( SampPoint, In.uv ) * fontColor0;
}

// hbvVhEi{PȂj
float4 DropShadow_PS( PS_IN In ) : COLOR0
{
	return tex2D( SampPoint, In.uv ) * fontColor1;
}

// hbvVhEi{Pej
float4 DropShadow2_PS( PS_IN In ) : COLOR0
{
	float4 col;
	col  = tex2D( SampPoint, float2( In.uv.x, In.uv.y ) );
	col += tex2D( SampPoint, float2( In.uv.x-blurDist, In.uv.y ) );
	col += tex2D( SampPoint, float2( In.uv.x+blurDist, In.uv.y ) );
	col += tex2D( SampPoint, float2( In.uv.x, In.uv.y-blurDist ) );
	col += tex2D( SampPoint, float2( In.uv.x, In.uv.y+blurDist ) );
	col *= 0.2;				// 5_̕ς߂ĊȈՂɂڂ
	return col * fontColor1;
}

// ܕ
float4 OutlineChar_PS( PS_IN In ) : COLOR0
{
	float4 col, col2;
	col2 = tex2D( SampPoint, float2( In.uv.x, In.uv.y ) );
	col  = tex2D( SampPoint, float2( In.uv.x-blurDist, In.uv.y ) );
	col += tex2D( SampPoint, float2( In.uv.x+blurDist, In.uv.y ) );
	col += tex2D( SampPoint, float2( In.uv.x, In.uv.y-blurDist ) );
	col += tex2D( SampPoint, float2( In.uv.x, In.uv.y+blurDist ) );
	col.w *= 1.25;			// Z̒ A`GCAXtƗ֊sȂ肪
	col = saturate( col );
	col.w *= 1.0 - col2.w;	// ̌̕`ɂʂ
	return col * fontColor0;
}



// eNjbN
// ʂɕ`
technique BasicTec
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_2_0 Diffuse_PS();
	}
}

// hbvVhEi{PȂj
technique BasicTec_1
{
	pass P0
	{
		VertexShader = compile vs_2_0 DropShadow_VS();
		PixelShader = compile ps_2_0 DropShadow_PS();
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_2_0 Diffuse_PS();
	}
}

// hbvVhEi{Pej
technique BasicTec_2
{
	pass P0
	{
		VertexShader = compile vs_2_0 DropShadow_VS();
		PixelShader = compile ps_2_0 DropShadow2_PS();
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_2_0 Diffuse_PS();
	}
}

// ܕ
technique BasicTec_3
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_2_0 OutlineChar_PS();
	}
}


